#ifndef CUETRACKLISTWIDGET_H
#define CUETRACKLISTWIDGET_H
#include <vector>
#include <QWidget>
#include <QScrollArea>
#include <QEvent>
#include <QKeyEvent>
#include <QShortcut>
#include <QVBoxLayout>
#include <QTableWidget>
#include <QTableWidgetItem>
#include "defines.h"
#include "editcuetrackwidget.h"

class CueTrackListWidget : public QWidget {
    Q_OBJECT

public:
    explicit CueTrackListWidget(QWidget *parent = nullptr);
    CueTrack* getSelectedTrack();
	void createNewCueTrack();
	void editCueTrack();
	void deleteCueTrack();
    int getSelectedIndex() { return selectedIndex; };
    CueTrack* getTrackAtIndex(int index);
    QString *getFileName(std::string s);

private:
    std::vector<CueTrack *> cueTracks;
    QVBoxLayout* layout;
    QTableWidget* tableWidget;
    int m_size = 0;
    int size() { return m_size; }
    int selectedIndex = 0;
    size_t lastUserCueNumber = 0;

private slots:
    void addCueTrack(CueTrack* cue);
    void removeCueTrack(int index);
    void key_up();
    void key_down();
    void displayCueTrackInTable(CueTrack *cueTrack, int index);
    void keyPressEvent(QKeyEvent* event);
    void updateSelectedCueTrack(bool highlightRow);
    void cueTrackLoadDefaults(CueTrack * t);
	void copyCueTrack(CueTrack *src, CueTrack *dst);

signals:
    void changeSelectedIndex(int index);
};
#endif
